        local showLinkType = {
            -- 1 Normal tooltip things:
            achievement  = 1,
            enchant      = 1,
            glyph        = 1,
            item         = 1,
            instancelock = 1,
            quest        = 1,
            spell        = 1,
            talent       = 1,
            unit         = 1,
            currency       = 1,
            -- 2 Special tooltip things:
            battlepet           = 2,
            battlePetAbil       = 2,
            garrfollowerability = 2,
            garrfollower        = 2,
            garrmission         = 2,
        }
       
        local currentLinkType, itemRefLink, itemRefText, itemRefFrame
         
        local function OnHyperlinkEnter(frame, link, text)
            currentLinkType = showLinkType[link:match("(%a+):%d+")]
            if currentLinkType == 1 then
                GameTooltip:SetOwner(ChatFrame1Tab, "ANCHOR_TOPLEFT", 20, 20)
                GameTooltip:SetHyperlink(link)
                GameTooltip:Show()
            elseif currentLinkType == 2 then
                -- Uses a special tooltip, just let the default function handle it.
                SetItemRef(link, text, "LeftButton", frame)
                itemRefLink, itemRefText, itemRefFrame = link, text, frame
            end
        end
     
        local function OnHyperlinkLeave(frame, link, text)
            if currentLinkType == 1 then
                GameTooltip:Hide()
            elseif currentLinkType == 2 then
                -- Uses a special tooltip, just let the default function handle it.
                SetItemRef(itemRefLink, itemRefText, "LeftButton", itemRefFrame)
                itemRefLink, itemRefText, itemRefFrame = nil,nil,nil
            end
            currentLinkType = nil
        end
         
        local function RegisterFrame(frame)
            frame:SetScript("OnHyperlinkEnter", OnHyperlinkEnter)
            frame:SetScript("OnHyperlinkLeave", OnHyperlinkLeave)
        end
         
        local f = CreateFrame("Frame")
        f:RegisterEvent("PLAYER_LOGIN")
        f:SetScript("OnEvent", function(self, event, name)
            if event == "PLAYER_LOGIN" then
                for i = 1, NUM_CHAT_WINDOWS do
                    RegisterFrame(_G["ChatFrame"..i])
                end
            end
            if GuildBankMessageFrame then
                RegisterFrame(GuildBankMessageFrame)
                self:UnregisterAllEvents()
                self:SetScript("OnEvent", nil)
                RegisterFrame = nil
            else
                self:RegisterEvent("ADDON_LOADED")
            end
        end)